 function add_my_T(t,Ti,Tn,dt,linewidth,markersize)
    
    x1=(Ti:dt:Tn);
    y=0*x1;
   
    plot(x1,y,'-g','linewidth',linewidth);
    hold on
    plot(t,y,'-rs',...
         'linewidth',1,...
	 'markeredgecolor','r',...
	 'markerfacecolor',[1 0 0],...
	 'markersize',markersize)
	 
    axis([Ti Tn -.05 .05])
    set(gca,'ycolor','w')
    set(gca,'ytick',[])
    set(gca,'xtick',[Ti:Tn])
    box off
       
return