clear all;close all;
%scrsz = [1 1 600 800]
scrsz = get(0,'ScreenSize');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
timemax=36%[h]
DT=0.1 %[h]
DX=1;%[km]

k=10%horizontal diffusion coefficient [m/s] Mattioli 10<A_H<10^6????

fluxSF6=10   %SF6 flux [l/min];
container=7500;%[l]
shipvel=4   %ship speed [knots];
detectiontreshold='n'

concentrico=1 %rotation sense of spirale
nn=30
pasX=0.5 %[km]
pasY=0.5 %[km]

vortextype='anti' %'cycl', 'anti'
maxvortexspeed=0.3   %max vortex speed [m/s]

m_proj('mercator','lon',[3 3.8],'lat',[42.3 42.7]);
[xc,yc]=m_ll2xy(3.5,42.6);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

concsat=1.77*10^-4;%[mol/l]
flux=100%[part/DT[h]]
partweight=fluxSF6*60*DT*concsat/flux%[mol/part]
indice=1;
k_km=k/10^6*3600; %[km^2/s]
devst=sqrt(2*k_km*DT) %standard deviation [km]
vel=shipvel*1.852;%[km/h]
res=1%don't touch!
myaxis='axis([-10 10 -10 10])';
deltatime=1/DT; %plot of conc each hour
itmax=timemax/DT; %nbre de pas de temps en jour

imax=100; %taille de la matrice CONC en m (boite o sont enferme les particules)
jmax=100; %taille de la matrice CONC en m
centerX=50;
centerY=50;
coeffspirale=1%1.1 %correspond to square of 7.15x7.15km 
it=0;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%call function to have ship trajectory
[xx,yy]=spirale_new(pasX,pasY,nn,90,0,0);%(pasX,pasY,max number of points,theta,xx0,yy0);
 if concentrico~=1
    xx=xx(end:-1:1);
    yy=yy(end:-1:1);
 end
%put trajectory in the common reference domain    
xx=xx+centerX;
yy=yy+centerY;
spirale_extentionX=max(xx)-min(xx)
spirale_extentionY=max(yy)-min(yy)

h=figure(1);hold on;
 set(h,'Position',[scrsz(3)/2 scrsz(4)/2 scrsz(3)/2 scrsz(4)/1.75])
% eval(myaxis)
% plot(xx-centerX,yy-centerY,'k-');
% xlabel(['distance X-dir [km]'])
% ylabel(['distance Y-dir [km]'])
 title(['\bf{TIME =',num2str(it*DT/res),'[h]    extentionX =',num2str(spirale_extentionX),'[km]    extentionY =',num2str(spirale_extentionY), '[km]}'])
% grid on
[lonspir,latspir]=m_xy2ll(xc+(xx-centerX)/6370,yc+(yy-centerY)/6370);
m_plot(lonspir,latspir,'k-');
m_usercoast('./sub_functions/GOL.mat','patch',[.6 .6 .6]); 
m_grid('box','fancy','tickdir','in');

h=figure(2);hold on;
  set(h,'Position',[1 scrsz(4)/2 scrsz(3)/2 scrsz(4)/1.75])
eval(myaxis)
  box on;
 % title(['k=',num2str(k),'   vel=',num2str(vel),'     flux=',num2str(flux),'    TIME =',num2str(it*DT/res),'[h]']);
   title(['\bf{k=',num2str(k),'[m^2/s]  shipvel=',num2str(shipvel),'[knots]   fluxSF6=',num2str(fluxSF6),'[l/min]   MaxSpeed=',num2str(maxvortexspeed),'[m/s]   TIME =',num2str(it*DT/res),'[h]}']);
%  xlabel(['distance X-dir [km]'])
%  ylabel(['distance Y-dir [km]'])
m_usercoast('./sub_functions/GOL.mat','patch',[.6 .6 .6]); 
m_grid('box','fancy','tickdir','in');

 h=figure(3);hold on;
  set(h,'Position',[scrsz(3)/1.5 10 scrsz(3)/4 scrsz(4)/3.3])
axis([0 1 0 7500])
  box on;
  it=0;
  title(['\bf{SF6 container    TIME =',num2str(it*DT/res),'[h]}']);
 ylabel('[l]')
figure(1)
pause

[trash,maxsize]=size(xx); 
xxnew(1)=xx(1);
yynew(1)=yy(1);
indice=2;
totdistanceKM=0;%[km]
for i=2:maxsize
    if xx(i-1)~=xx(i)
     distance=[max(xx(i-1),xx(i)) - min(xx(i-1),xx(i))];%[km]
     ipunti=round(distance/vel/DT*res);%qui velocita no? 10 per aumentare res
     indicenew=indice+ipunti;
     if xx(i-1)>xx(i)
         xxnew(indice:indicenew)=[max(xx(i-1),xx(i)):-(distance/ipunti):min(xx(i-1),xx(i))];
     else
         xxnew(indice:indicenew)=[min(xx(i-1),xx(i)):(distance/ipunti):max(xx(i-1),xx(i))];
     end
     yynew(indice:indicenew)=yy(i-1);
    else
     distance=[max(yy(i-1),yy(i)) - min(yy(i-1),yy(i))];
     ipunti=round(distance/vel/DT*res);%qui velocita no?
     indicenew=indice+ipunti;
     if yy(i-1)>yy(i)
         yynew(indice:indicenew)=[max(yy(i-1),yy(i)):-(distance/ipunti):min(yy(i-1),yy(i))];
     else
         yynew(indice:indicenew)=[min(yy(i-1),yy(i)):(distance/ipunti):max(yy(i-1),yy(i))];
     end         
     xxnew(indice:indicenew)=xx(i-1);
    end %if
    indice=indicenew;
    totdistanceKM=totdistanceKM+distance;
end %for
totdistanceKM
maxtimeHspiral4knots=totdistanceKM/4/1.852

% figure(1);hold on
% %axis([40 60 40 60])
% plot(xxnew-centerY,yynew-centerY,'ro-');
% grid on;
%pause

% add velocity of an eddy
[XX,YY,uu,vv]=vortex(vortextype,-0.50,0.50,-0.50,0.50,100,100);
uu=uu.*1000./3600.*10.*maxvortexspeed;%[m/s]
vv=vv.*1000./3600.*10.*maxvortexspeed; 
max(max(sqrt(uu.^2+vv.^2)))
distanceX=[-centerX:DX:centerX-DX];
distanceY=[-centerY:DX:centerY-DX];
figure(1);hold on
%quiver(distanceX,distanceY,uu,vv,2)
[lonspir,latspir]=m_xy2ll(xc+distanceX/6370,yc+distanceY/6370);
%lonspir=lonspir';
for i=1:100;for j=1:100;lat(i,j)=latspir(i);end;end;
for i=1:100;for j=1:100;lon(j,i)=lonspir(i);end;end;
m_quiver(lon,lat,uu,vv)
m_usercoast('./sub_functions/GOL.mat','patch',[.6 .6 .6]); 

pause

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%random walk with release along trajectory
[trash,maxsize]=size(xxnew);
shipdistanceKM=0
for it=1:itmax
    %%%% DT=1hour
    shipdistanceKM=shipdistanceKM+vel*DT
    container=container-fluxSF6*DT*60;%[l]

    
 if(it<=maxsize)&container>0
     xold(it*flux-(flux-1):it*flux)=xxnew(it);
     yold(it*flux-(flux-1):it*flux)=yynew(it);
     memoxxnew=xxnew(it);
     memoyynew=yynew(it);
     memoit=it;
 end
 [trash,ipmax]=size(xold);
 
 for ip=1:ipmax
  g=0;
  for i=1:12
   r=rand;
   g=g+(r-0.5);
  end
  depx=g*devst;
  h=0;
  for i=1:12
   r=rand;
   h=h+(r-0.5);
  end
  depy=h*devst;
  X(ip)=xold(ip)+depx;
  Y(ip)=yold(ip)+depy;
  
  if Y(ip)>100 | X(ip)>100 | X(ip)<2 | Y(ip)<2
   X(ip)=X(ip);
   Y(ip)=Y(ip);
  else
   X(ip)=X(ip)+uu(fix(Y(ip)),fix(X(ip)))*DT;
   Y(ip)=Y(ip)+vv(fix(Y(ip)),fix(X(ip)))*DT;
  end
  % condition  la frontiere
  if X(ip)<1 | X(ip)>100 | Y(ip)<1 | Y(ip)>100
   %frontire ferme
   X(ip)=xold(ip);
   Y(ip)=yold(ip);
  end
  xold(ip)=X(ip);
  yold(ip)=Y(ip);
 end %pour ip
 
 clf(1,'reset')
 
 h=figure(1);hold on
 %set(h,'Position',[scrsz(3)/2 scrsz(4)/2 scrsz(3)/2 scrsz(4)/2])
 %eval(myaxis)
 %plot(xx-centerX,yy-centerY,'k*-');
 %quiver(distanceX,distanceY,uu,vv,2)
 m_quiver(lon,lat,uu,vv)
%  plot(xxnew-centerX,yynew-centerY,'r-');
 [lonspir,latspir]=m_xy2ll(xc+(xxnew-centerX)/6370,yc+(yynew-centerY)/6370);
 m_plot(lonspir,latspir,'r-');
%  plot(xold-centerX,yold-centerY,'g.')
 [lonspir,latspir]=m_xy2ll(xc+(xold-centerX)/6370,yc+(yold-centerY)/6370);
 m_plot(lonspir,latspir,'g.');
 
 if container>0
%   plot(xxnew(1:it)-centerX,yynew(1:it)-centerY,'k-');
%   plot(xxnew(it)-centerX,yynew(it)-centerY,'kv');
  [lonspir,latspir]=m_xy2ll(xc+(xxnew(1:it)-centerX)/6370,yc+(yynew(1:it)-centerY)/6370);
  m_plot(lonspir,latspir,'k-');
  [lonspir,latspir]=m_xy2ll(xc+(xxnew(it)-centerX)/6370,yc+(yynew(it)-centerY)/6370);
  m_plot(lonspir,latspir,'kv');
 else
%  plot(xxnew(1:memoit)-centerX,yynew(1:memoit)-centerY,'k-');
%  plot(memoxxnew-centerX,memoyynew-centerY,'kv');
  [lonspir,latspir]=m_xy2ll(xc+(xxnew(1:memoit)-centerX)/6370,yc+(yynew(1:memoit)-centerY)/6370);
  m_plot(lonspir,latspir,'k-');
  [lonspir,latspir]=m_xy2ll(xc+(memoxxnew-centerX)/6370,yc+(memoyynew-centerY)/6370);
  m_plot(lonspir,latspir,'kv');
 end
title(['\bf{TIME =',num2str(it*DT/res),'[h]}'])
%  xlabel(['distance X-dir [km]'])
%  ylabel(['distance Y-dir [km]'])
m_usercoast('./sub_functions/GOL.mat','patch',[.6 .6 .6]); 
m_grid('box','fancy','tickdir','in');
 pause(0.1)
 hold off

%Afin de n'afficher la figure que tous les 'deltatimes' pas de temps
 if rem(it,deltatime)==0
  CONC=zeros(jmax,imax);
  %devst
  for ip=1:ipmax
   %Calcule le nombre de particules dans chaque maille
   ii=fix(X(ip));
   jj=fix(Y(ip));
   CONC(jj,ii)=CONC(jj,ii)+1;
  end
  distanceX=[-centerX:DX:centerX-DX];
  distanceY=[-centerY:DX:centerY-DX];
 
  clf(2,'reset')
  
  CONC=CONC.*partweight/(1000*DX)^2;%[mol/l]
  if detectiontreshold=='y';
  CONC(find(CONC<0.2*10^-15))=NaN;
  end
  %contourf(distanceX,distanceY,CONC(:,:)./ipmax,[0:1:20]./ipmax);shading flat;
  %contourf(distanceX,distanceY,CONC,[0:0.01:1].*10^-6);shading flat;
  m_contourf(lon,lat,CONC);shading flat;
m_usercoast('./sub_functions/GOL.mat','patch',[.6 .6 .6]); 
m_grid('box','fancy','tickdir','in');
  hold on;
  %plot(xx-centerX-DX,yy-centerY-DX,'w-');
%   quiver(distanceX,distanceY,uu,vv,2,'w');
%   %text(memoxxnew-centerX,memoyynew-centerY,'* SF6 container empty')
%   eval(myaxis)
%   box on;
  h=colorbar;
  set(get(h,'ylabel'),'string','[mol/l]');
    title(['\bf{k=',num2str(k),'[m^2/s]  shipvel=',num2str(shipvel),'[knots]   fluxSF6=',num2str(fluxSF6),'[l/min]   MaxSpeed=',num2str(maxvortexspeed),'[m/s]   TIME =',num2str(it*DT/res),'[h]}']);
%title(['k=',num2str(k),'[m^2/s]   shipvel=',num2str(shipvel),'[knots]    fluxSF6=',num2str(fluxSF6),'[l/min]    MaxVortexSpeed=',num2str(maxvortexspeed),'[m/s]    TIME =',num2str(it*DT/res),'[h]']);
  %axis([1 100 1 100])
 %axis square
%  xlabel(['distance X-dir [km]'])
%  ylabel(['distance Y-dir [km]'])
 
 %quiver(uu,vv,'w')
 %saveas(1,['CONC_k=',num2str(k),'_vel',num2str(vel),'_flux',num2str(flux),'_it',num2str(it),'.pdf'])
%print('-djpeg10',['testLATEX/CONC_k=',num2str(k),'_vel',num2str(vel),'_flux',num2str(flux),'_ctri',num2str(concentrico),'vortex_it',num2str(it),'.jpg'])
 CONCtime(it/deltatime,:,:)=CONC;
 ittime(it/deltatime)=it;
 ipmaxtime(it/deltatime)=ipmax;
 save testLATEX/memoconc k flux vel CONCtime ittime ipmaxtime concentrico
 
 end
figure(3);
clf(3,'reset')
if container>0
 bar(1,container,100,'g')
 itmemo=it;
 shipdistanceKMmemo=shipdistanceKM;
 title(['\bf{SF6 remaining =',num2str(container),'[l]}'])
else
 text(0.2,4000, ['\bf{SF6 container empty after}'])
 text(0.3,3000, ['\bf{',num2str(itmemo*DT/res),'[h]    ',num2str(shipdistanceKMmemo),'[km]}'])
end
axis([0 1 0 7500]);box off;


end %it
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5
