%cd '/home/a205637/adcp/ecolo_juin05_julie/adcp/'

%cd '/home/a205637/adcp/dec05ecolo'
cd '/home/a205637/adcp/ECOLO-03/adcp'
%path=uigetfile('*.mat','Quel fichier Thetis II tt bo ki marche?');
lectselection
load(path)
[lignes colones]=size(ensemble);
% calcule des profonfeudeur de bin
% for Nbin_thetis=1:nCells
% profbin_thetis(Nbin_thetis)=8.33+(Nbin_thetis-1)*4;
% end
% minimise la distance entre le profondeur desire et la possible, donne
% l'increment donc le numero de bin qui coorespond
%[distbin_thetis Nbin_thetis]=min(abs(profbin_thetis-prof_desiree));
%close all
hold on
golts

deb=10;
fin=length(ensemble(:,13))-00;
mib=20;

jjadcp_thetis=datenum(ensemble(:,4),ensemble(:,5),ensemble(:,6),ensemble(:,7),ensemble(:,8),ensemble(:,9));

%debthetis=datenum(2005,6,1,20,0,0);
%finthetis=datenum(2005,6,2,10,0,0);
%debthetis=datenum(2005,12,10,15,20,0);
%finthetis=datenum(2005,12,10,23,01,0);
debthetis=datenum(2006,06,25,0,0,0);
finthetis=datenum(2006,06,25,19,31,0);

indthetis=find(((jjadcp_thetis>=debthetis) & (jjadcp_thetis<=finthetis)));
deb=indthetis(1);
fin=indthetis(end);

%quiver(ensemble(1300:1440,14),ensemble(1300:1440,13),eastCurrentComponent(1300:1440,4)/100,northCurrentComponent(1300:1440,4)/100,'g')
quiver(ensemble(deb:fin,14),ensemble(deb:fin,13),eastCurrentComponent(deb:fin,mib)/1000,northCurrentComponent(deb:fin,mib)/1000,0)
text(ensemble(deb,14),ensemble(deb,13),datestr(2+ensemble(deb,11)),'fontsize',15)
text(ensemble(fin,14),ensemble(fin,13),datestr(2+ensemble(fin,11)),'fontsize',15)
text(5,42.5,datestr(2+ensemble(fin,11)),'fontsize',15)
%bottom(1:nEnsembles) profondeur sous adcp 
%botton(1320:1440)
hold on 

%export facile

ecriture=0
if ecriture==1 
%clear x,y,u,v
x=ensemble(deb:fin,14);
y=ensemble(deb:fin,13);
u=eastCurrentComponent(deb:fin,2)/100;
v=northCurrentComponent(deb:fin,2)/100;
date_bato=jjadcp_thetis(deb:fin);
save 26jun_12m.mat x y u v date_bato
'sauve des eaux'
end
%%%% fin export

%%%% profondeur en fonction de la couleur

profmin=0;
profmax=-270;
figure
golts
colorbar
c=colormap;
c=zeros(-profmax,3);
colormap(c)
colormap('jet')
invcolorbar% fonction made in alex
c=colormap;
colorbar
inc=profmin:-1:profmax;
carteprofTHETIS(1)=10.29;
for i=2:nCells
    carteprofTHETIS(i)=carteprofTHETIS(i-1)+4;
    [val,pro]=min(abs(-carteprofTHETIS(i)-inc));
    hold on,quiver(ensemble(deb:fin,14),ensemble(deb:fin,13),eastCurrentComponent(deb:fin,i)/1000,northCurrentComponent(deb:fin,i)/1000,0,'Color',c(pro,:))
end


%%%%% couleur en fonction de l'erreur

profmin=0;
profmax=-270;

errmax=nanmax(nanmax(abs(verr)));
errmin=nanmin(nanmin(abs(verr)));
if errmax>10
    errmax=10%cm/s
end
figure
golts
colorbar
c=colormap;
c=zeros(400,3);
colormap(c)
colormap('jet')
%invcolorbar% fonction made in alex
c=colormap;

inc=profmin:-1:profmax;
carteERR=linspace(errmin,errmax,400);
carteERR=sort(carteERR,'ascend')/100;
%
%indaff=1:10;
%indaff=[indaff,10:15:length(carteERR)];
caxis([errmin,errmax])
carteprofTHETIS(1)=10.29;
for i=mib:mib%nCells
    for j=deb:fin
    carteprofTHETIS(i)=carteprofTHETIS(i-1)+4;
    [val,pro]=min(abs(-carteprofTHETIS(i)-inc));
    [val,codeERR]= min(abs(abs(verr(j,i)/100)-carteERR));
    hold on,quiver(ensemble(j,14),ensemble(j,13),eastCurrentComponent(j,i)/1000,northCurrentComponent(j,i)/1000,0,'Color',c(codeERR,:))
    end
end

colorbar('YTick',floor(100*carteERR(1:5:end)))




%%%%%%%%%%% couleur en fonction du module

profmin=0;
profmax=-270;

errmax=nanmax(nanmax(abs(speedCurrentComponent)));
errmin=nanmin(nanmin(abs(speedCurrentComponent)));
 if errmax>70
     errmax=70%cm/s
 end
figure
golts
colorbar
c=colormap;
c=zeros(400,3);
colormap(c)
colormap('jet')
%invcolorbar% fonction made in alex
c=colormap;

inc=profmin:-1:profmax;
carteERR=linspace(errmin,errmax,400);
carteERR=sort(carteERR,'ascend')/100;
%
%indaff=1:10;
%indaff=[indaff,10:15:length(carteERR)];
caxis([errmin,errmax])
carteprofTHETIS(1)=10.29;
for i=mib:mib%nCells
    for j=deb:fin
    carteprofTHETIS(i)=carteprofTHETIS(i-1)+4;
    [val,pro]=min(abs(-carteprofTHETIS(i)-inc));
    [val,codeERR]= min(abs(abs(speedCurrentComponent(j,i)/100)-carteERR));
    hold on,quiver(ensemble(j,14),ensemble(j,13),eastCurrentComponent(j,i)/1000,northCurrentComponent(j,i)/1000,0,'Color',c(codeERR,:))
    end
end
colorbar('YTick',floor(100*carteERR(1:5:end)))


%%%%%%%%%%% couleur en fonction de la temperature a la tete de l adcp

errmax=nanmax(nanmax(abs(sensors(:,4))));
errmin=nanmin(nanmin(abs(sensors(:,4))));
 if errmax>70
     errmax=70%cm/s
 end
figure
golts
colorbar
c=colormap;
c=zeros(400,3);
colormap(c)
colormap('jet')
%invcolorbar% fonction made in alex
c=colormap;

inc=profmin:-1:profmax;
carteERR=linspace(errmin,errmax,400);
carteERR=sort(carteERR,'ascend')/100;
%
%indaff=1:10;
%indaff=[indaff,10:15:length(carteERR)];
caxis([errmin,errmax])
carteprofTHETIS(1)=10.29;
for i=mib:mib%nCells
    for j=deb:fin
    carteprofTHETIS(i)=carteprofTHETIS(i-1)+4;
    [val,pro]=min(abs(-carteprofTHETIS(i)-inc));
    [val,codeERR]= min(abs(abs(speedCurrentComponent(j,i)/100)-carteERR));
    hold on,quiver(ensemble(j,14),ensemble(j,13),eastCurrentComponent(j,i)/1000,northCurrentComponent(j,i)/1000,0,'Color',c(codeERR,:))
    end
end
colorbar('YTick',floor(100*carteERR(1:5:end)))
