clear;
close all;

figure(1);hold on
%m_gshhs_h('save','NWMed')
%m_proj('mercator','lon',[0 11],'lat',[38 44.8])
m_proj('mercator','lon',[2.8 6],'lat',[42 43.8])
m_usercoast('NWMed','patch',[.5 .5 .5]);
%m_coast('patch',[.5 .5 .5]);
m_grid('box','fancy','tickdir','in');
m_text(5.4,43.25,'\bf{MARSEILLE}');

%ncload('./Henrick/20010701_000000_181.nc')
%save bathy_m.mat bathy_m lon lat
load bathy_m.mat
[c,h]=m_contour(lon,lat,bathy_m,[50 100 200 500 1000 2000]);
clabel(c,h)%,'fontsize',15,'color','r','rotation',0)

% 1) Boue Nord de la Rserve Naturelle - Balise 80583
% 43 29,196 3 09,999 Sonde : 42 m Flotteur Blanc 
%AD: 43???? 42!!!
lat=42+(29.196/60)
lon=3+(9.999/60)
m_text(lon, lat,'\bf{M1}')
% 2) Zone des Canelottes  Balise 01243
% 42 32,962 3 15,424 Sonde : 85 m Flotteur Rouge
lat=42+(32.962/60)
lon=3+(15.424/60)
m_text(lon, lat,'\bf{M2}')
% 3) Tte de Lacaze Duthiers  Balise 26476
% 42 36,384 3 24,068 Sonde : 214 m Flotteur Jaune
lat=42+(36.384/60)
lon=3+(24.068/60)
m_text(lon, lat,'\bf{M3}')

saveas(1,'carte_mouillages','epsc2')
saveas(1,'carte_mouillages','jpg')

