clear;close all;
% %
%%%% treatement of AVHRR images
dirin_AVHRR='..\AVHRR \'
[xim,yim,imc4]=plot_AVHRR(dirin_AVHRR);

close
lonAVHRR=xim;
latAVHRR=yim;
sstAVHRR=imc4;


%%% PARAMETERS
%
%- area limits -% (in degres)
lon_min =  3;
lon_max =  4;
lat_min = 41.9;
lat_max = 42.8;
%
%- Geographip projection for m_map -%
projection = 'mercator';
%
%- User coast in dirin -%
UserCoast='GOL.mat'; % in "sub_functions" directory
dirin ='..\Bouee_NicolasMartin\';
%
%%% FIGURE
figure(1);hold on
m_proj(projection,'lon',[lon_min lon_max],'lat',[lat_min lat_max]);
%
%
 m_pcolor(lonAVHRR,latAVHRR,sstAVHRR)
pause
%
%%% ARGOS BUOY
interval=[datenum(2010,9,14,20,0,0) datenum(2010,9,15,20,00,0)]
%%%% Buoys lauchend at last round of spiral
plot_Argos_buoys_id(dirin,83631,'w-',interval);
plot_Argos_buoys_id(dirin,93265,'w-',interval);
plot_Argos_buoys_id(dirin,47833,'w-',interval);
plot_Argos_buoys_id(dirin,47835,'w-',interval);
%
%%% COASTLINE
m_usercoast(UserCoast,'patch',[.7 .7 .7],'edgecolor','k');
%m_coast('patch',[.7 .7 .7],'edgecolor','k');
%
%%% LAT-LON PROJECTION
m_grid('box','fancy','tickdir','in');
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%