%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% plot_SF6_1D.m
% AP 16/09/2010
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all
clf

load sf6_mapping_vessel_coord_nb1_VStethys.txt
load sf6_mapping_vessel_coord_nb2_VStethys.txt
sf=sf6_mapping_vessel_coord_nb1_VS;
sf2=sf6_mapping_vessel_coord_nb2_VS;


%%%% figure
subplot(211),plot(sf(:,8))
hold on
plot(sf(:,8),'x')
plot(sf2(:,8),'g')
plot(sf2(:,8),'gx')
text(20,400000,['M11 = ',int2str(max(sf(:,8)))])
text(20,350000,['M12 = ',int2str(max(sf(1:20,8)))])
title('LATEX 10 - SF6 - Mapping 1 and 2')

subplot(212),plot(sf2(:,8),'g')
hold on
plot(sf2(:,8),'gx')
title('SF6 - Mapping 2 & Peak comparisons')

text(20,40000,['M21 = ',int2str(max(sf2(:,8)))])
text(60,40000,['M11/M21=',int2str(max(sf(:,8))/max(sf2(:,8)))])
text(60,35000,['M12/M21=',int2str(max(sf(1:20,8))/max(sf2(:,8)))])

%print plot_SF6_1D.tiff -dtiff
