%%%%% traiter des donnes .nc

close all; clear all;
%% ouvrir les donnes, et donner le nom par la date
jan=netcdf('nwm_jan_2001.nc','nowrite');


set(gcf,'visible','off');  %connecte en mode graphique
set(gcf,'color','white')

%  charger les donnes
lon=jan{'lon'}(:);  % longitude
lat=jan{'lat'}(:);  % latitude
%dpt=jan{'dpt'}(:);  % depth
sse=jan{'sse'}(:);  %l'lvation de la surface 4 D (23times)
sseint=squeeze(sse(1,:,:));
%sseint(116,340)=0;for i=1:23;sseint(i)=squeeze(sse(i,:,:));end
%vly=jan{'vly'}(:);
%vlx=jan{'vlx'}(:);
%tem=jan{'tem'}(:);

figure(1)

m_proj('mercator','longitudes',[-1.77115 10.9287],'latitudes',[38.2815 45.6427]);
m_pcolor(lon,lat,sseint);
minsse=min(min(sseint)); maxsse=max(max(sseint));
m_contour(lon,lat,sseint,[-.2:.01:.2]);
%m_grid('box','fancy','tickdir','out');
m_grid('box','fancy','fontsize',7);
hold on
m_usercoast('nwmed.mat','color','k');
hold off
caxis([0 37])  % saturation colorbar
h=colorbar('horizontal');
%C(:,:)=Ctmp(23,40,:,:);  % je pense que le 23 correspond a un niveau sigma 
                        % et le 40 a une date mais je suis pas  
                        % sur a toi de voir 


%C(find(C==-9999))=NaN;  % pour enlever les -9999


set(h,'LineWidth',0.0001) %pour des beaux graphs

