clear;close all;
%%% PARAMETERS
%
%- area limits -% (in degres)
lon_min =  3.25;
lon_max =  3.75;
lat_min = 42.6;
lat_max = 42.9;
%
%- Geographip projection for m_map -%
projection = 'mercator';
%
%- User coast in dirin -%
UserCoast='GOL.mat'; % in "sub_functions" directory
dirin='..\Bouee_NicolasMartin\';
%
%%% FIGURE
figure(1);hold on
m_proj(projection,'lon',[lon_min lon_max],'lat',[lat_min lat_max]);

%%%% Buoys lauchend off LaSeyne
% plot_Argos_buoys_id(dirin,48943,'ko')
% plot_Argos_buoys_id(dirin,48944,'go')
% plot_Argos_buoys_id(dirin,48945,'yo')
% plot_Argos_buoys_id(dirin,48946,'ro')

%%%% CARIOCA buoy
%?????????????

%%%% IRIDIUM buoy
plot_Argos_buoys_id(dirin,300034012011820,'ro-')

%%%% Buoys lauchend at last round of spiral
plot_Argos_buoys_id(dirin,83631,'r*-')
plot_Argos_buoys_id(dirin,93265,'b*-')
plot_Argos_buoys_id(dirin,47833,'k*-')
plot_Argos_buoys_id(dirin,47835,'g*-')
plot_Argos_buoys_id(dirin,48863,'y*-')
plot_Argos_buoys_id(dirin,48903,'c*-')
plot_Argos_buoys_id(dirin,48920,'m*-')
plot_Argos_buoys_id(dirin,48939,'r*:')
plot_Argos_buoys_id(dirin,48940,'b*:')
plot_Argos_buoys_id(dirin,29457,'k*:')
plot_Argos_buoys_id(dirin,29491,'g*:')

pause

%plot_Argos_buoys_id(dirin,30448,'k+-')
%plot_Argos_buoys_id(dirin,30394,'k+:')
%plot_Argos_buoys_id(dirin,26128,'ko-')
%plot_Argos_buoys_id(dirin,30471,'ko:')

%%% COASTLINE
m_usercoast(UserCoast,'patch',[.7 .7 .7],'edgecolor','k');
%m_coast('patch',[.7 .7 .7],'edgecolor','k');
%
%%% LAT-LON PROJECTION
m_grid('box','fancy','tickdir','in');
%
