
clear all
close all

dirin='..\Avhrr\';
filename=[dirin,'-var-ftp-pub-CMS_GOLTS-png_gray-201009140152.png'];
%interval=[datenum(2010,9,13,14,0,0) datenum(2010,9,14,14,0,0)]

% filename=[dirin,'-var-ftp-pub-CMS_GOLTS-png_gray-201009150847.png'];
interval=[now-2.5 now]%datenum(2010,9,16,21,0,0)]





files=dir(filename);
% since we don't present all the figures of August, this loop helps us to go to directly the begining one
if isempty(files)==1;   
   d=d+1;
else
fname4=files.name;
Pss=imread([dirin,fname4]);
Pss=double(Pss);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Prepare Matix of Avhrr %%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


    % Definition of Avhrr image domain, 
    % Vallues obtained from v4.4, choosing GOL
    up_left_lon = 3;
    up_left_lat = 43.6;
    X_pixels = 500; %  same size as P
    Y_pixels = 260;
    % Resolution
    res = 0.01;
    % Suppress cloud and earth points
    Pss(find(Pss==255))=NaN;
    Pss(find(Pss==0))=NaN;
    % Convert to Brightness Temperature
    Pss=0.1*Pss+5; % deg C
    % Title
    [pathstr,name,ext,versn] = fileparts([dirin,fname4]);
    s.bar_title=['AVHRR - (' name ext versn ')'];
%      Plat=up_left_lat-[0:(Y_pixels-1)]*res;
%      Plon=up_left_lon+[0:(X_pixels-1)]*res;
Plon=2.45+[1:500]*0.01;
Plat=40.98+[260:-1:1]*0.01;
        % Since the grid is rectangluar in lat/long (i.e. not
        % really a projection at all, althouhg it is included in
        % m_map under the name 'equidistant cyldindrical'), we
        % don't want to use the 'image' technique. Instead...
        % Create a grid, offsetting by half a grid point to account
        % for the flat pcolor
        %[Plg,Plt]=meshgrid(Plon+res*0.5,Plat-res*0.5);
    [Plg,Plt]=meshgrid(Plon,Plat);
%      palette=jet(256);
    palette=jet(512);

%%%%%%%%%%%%%%%%%%%%%%%
%%%% Plot the image %%%
%%%%%%%%%%%%%%%%%%%%%%%
%- area limits -% (in degres)
lon_min =  3;
lon_max =  4;
lat_min = 41.9;
lat_max = 42.8;
%
%- Geographip projection for m_map -%
projection = 'mercator';
%
%- User coast in dirin -%
UserCoast='GOL.mat'; % in "sub_functions" directory
dirin ='..\Bouee_NicolasMartin\';
%
%%% FIGURE
figure(1);hold on
m_proj(projection,'lon',[lon_min lon_max],'lat',[lat_min lat_max]);
%
%      m_pcolor(Plg,Plt,Pss);
%          shading flat;
%      shading flat;
    colormap(palette);
      s.minClim=min(Pss(~isnan(Pss)));
      s.maxClim=max(Pss(~isnan(Pss)));
    % Fix the colorbar
       s.minClim=15;
       s.maxClim=19;

       
       Pss(find(Pss<s.minClim))=s.minClim;
Pss(find(Pss>s.maxClim))=s.maxClim;
m_contourf(Plg,Plt,Pss,[s.minClim:0.1:s.maxClim]);   shading flat;

% % %      set(gca,'CLim',[s.minClim s.maxClim]);
% %     s.bar=colorbar;
% %     set(s.bar,'YTick',[s.minClim:0.4:s.maxClim],'Location','EastOutside');  
end










%
%  m_pcolor(lonAVHRR,latAVHRR,sstAVHRR)
% pause
%
%%% ARGOS BUOY

%%%% Buoys lauchend at last round of spiral
plot_Argos_buoys_id(dirin,83631,'k-',interval);
plot_Argos_buoys_id(dirin,93265,'k-',interval);
plot_Argos_buoys_id(dirin,47833,'k-',interval);
plot_Argos_buoys_id(dirin,47835,'k-',interval);
%
%% Bouee recuperes le 15 Sept
 plot_Argos_buoys_id(dirin,48863,'k-',[now-2 now-1.5]);
 plot_Argos_buoys_id(dirin,48903,'k-',[now-2 now-1.5]);
 plot_Argos_buoys_id(dirin,48920,'k-',[now-2 now-1.5]);
 plot_Argos_buoys_id(dirin,48939,'k-',[now-2 now-1.5]);
 plot_Argos_buoys_id(dirin,48940,'k-',[now-2 now-1.5]);

%%% COASTLINE
m_usercoast(UserCoast,'patch',[.7 .7 .7],'edgecolor','k');
%m_coast('patch',[.7 .7 .7],'edgecolor','k');
m_grid